# Class OjTableBase

This is the base class for oj-table WebElement, and is generated from the component's metadata. Do not modify these contents since they'll be replaced during the next generation. Put overrides into the WebElements's subclass, OjTable.ts.

#### Hierarchy

- OjWebElement
  - OjTableBase
    - OjTable

#####
Index

### Constructors

constructor

### Methods

changeColumns
changeCurrentRow
changeEditRow
changeInsertRowDisplay
changeScrollPosition
changeSelected
changeSelection
clear
click
findElement
findElements
getAccessibility
getAddRowDisplay
getAs
getAttribute
getColumnResizeBehavior
getColumns
getColumnsDefault
getCssValue
getCurrentRow
getDisplay
getDnd
getEditMode
getEditRow
getFirstSelectedRow
getHorizontalGridVisible
getInsertRowDisplay
getLayout
getLocation
getProperty
getRect
getRow
getRowRenderer
getScrollPolicy
getScrollPolicyOptions
getScrollPosition
getScrollToKey
getSelectAllControl
getSelected
getSelection
getSelectionMode
getSelectionRequired
getSize
getText
getTranslations
getVerticalGridVisible
hasSize
hasVisibility
isDisplayed
isEnabled
isSelected
sendKeys
setProperty
submit
takeScreenshot
whenBusyContextReady
whenReady

## Constructors

### constructor

- new OjTableBase(el, locators): OjTableBase

- Constructor. Pass an instance of WebDriver's WebElement that represents the DOM node on which we"ll perform operations.

  #### Parameters

  - ##### el: WebElement

    The basic WebElement with which this WebElement will work.

  - ##### locators: ElementLocators

  #### Returns OjTableBase

  Inherited from OjWebElement.constructor

## Methods

### changeColumns

- changeColumns(columns): Promise<void>

- Sets the value of `columns` property. An array of column definitions. See the Help documentation for more information.

  #### Parameters

  - ##### columns: null | Columns[]

    The value to set for `columns`

  #### Returns Promise<void>

### changeCurrentRow

- changeCurrentRow(currentRow): Promise<void>

- Sets the value of `currentRow` property. Specifies the row that currently has keyboard focus. See the Help documentation for more information.

  #### Parameters

  - ##### currentRow: object

    The value to set for `currentRow`

  #### Returns Promise<void>

### changeEditRow

- changeEditRow(editRow): Promise<void>

- Sets the value of `editRow` property. Specifies the row that is currently being edited. See the Help documentation for more information.

  #### Parameters

  - ##### editRow: object

    The value to set for `editRow`

  #### Returns Promise<void>

### changeInsertRowDisplay

- changeInsertRowDisplay(insertRowDisplay): Promise<void>

- Sets the value of `insertRowDisplay` property. Specifies the visible location of the insert new row when addRowTemplate or addRowCellTemplate is present.

  #### Parameters

  - ##### insertRowDisplay: object

    The value to set for `insertRowDisplay`

  #### Returns Promise<void>

### changeScrollPosition

- changeScrollPosition(scrollPosition): Promise<void>

- Sets the value of `scrollPosition` property. Specifies the scroll position of the table. See the Help documentation for more information.

  #### Parameters

  - ##### scrollPosition: ScrollPosition

    The value to set for `scrollPosition`

  #### Returns Promise<void>

### changeSelected

- changeSelected(selected): Promise<void>

- Sets the value of `selected` property. Specifies the current selected rows and/or columns in the table. See the Help documentation for more information.

  #### Parameters

  - ##### selected: Selected

    The value to set for `selected`

  #### Returns Promise<void>

### changeSelection

- changeSelection(selection): Promise<void>

- Sets the value of `selection` property. Specifies the current selections in the table. See the Help documentation for more information.

  #### Parameters

  - ##### selection: object[]

    The value to set for `selection`

  #### Returns Promise<void>

  #### Deprecated

  Since 7.0.0. Use selected attribute instead.

### clear

- clear(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjWebElement.clear

### click

- click(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjWebElement.click

### findElement

- findElement(locator): WebElementPromise

- #### Parameters

  - ##### locator: Locator

  #### Returns WebElementPromise

  #### Inherit Doc

  Inherited from OjWebElement.findElement

### findElements

- findElements(locator): Promise<WebElement[]>

- #### Parameters

  - ##### locator: Locator

  #### Returns Promise<WebElement[]>

  #### Inherit Doc

  Inherited from OjWebElement.findElements

### getAccessibility

- getAccessibility(): Promise<null | Accessibility>

- Gets the value of `accessibility` property. Accessibility attributes.

  #### Returns Promise<null | Accessibility>

  The value of `accessibility` property.

### getAddRowDisplay

- getAddRowDisplay(): Promise<string>

- Gets the value of `addRowDisplay` property. Specifies whether to show or hide add new row when addRowTemplate or addRowCellTemplate is present.

  #### Returns Promise<string>

  The value of `addRowDisplay` property.

### getAs

- getAs(): Promise<string>

- Gets the value of `as` property. An alias for the '$current' context variable passed to the content of the cell template.

  #### Returns Promise<string>

  The value of `as` property.

  #### Deprecated

  Since 6.2.0. Set the alias directly on the template element using the data-oj-as attribute instead.

### getAttribute

- getAttribute(attributeName): Promise<string>

- #### Parameters

  - ##### attributeName: string

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjWebElement.getAttribute

### getColumnResizeBehavior

- getColumnResizeBehavior(): Promise<string>

- Gets the value of `columnResizeBehavior` property. Specifies the column resize behavior for this Table. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `columnResizeBehavior` property.

### getColumns

- getColumns(): Promise<null | Columns[]>

- Gets the value of `columns` property. An array of column definitions. See the Help documentation for more information.

  #### Returns Promise<null | Columns[]>

  The value of `columns` property.

### getColumnsDefault

- getColumnsDefault(): Promise<null | ColumnsDefault>

- Gets the value of `columnsDefault` property. Default values to apply to all column objects.

  #### Returns Promise<null | ColumnsDefault>

  The value of `columnsDefault` property.

### getCssValue

- getCssValue(cssStyleProperty): Promise<string>

- #### Parameters

  - ##### cssStyleProperty: string

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjWebElement.getCssValue

### getCurrentRow

- getCurrentRow(): Promise<object>

- Gets the value of `currentRow` property. Specifies the row that currently has keyboard focus. See the Help documentation for more information.

  #### Returns Promise<object>

  The value of `currentRow` property.

### getDisplay

- getDisplay(): Promise<string>

- Gets the value of `display` property. Specifies whether to display this table in list or grid mode. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `display` property.

### getDnd

- getDnd(): Promise<Dnd>

- Gets the value of `dnd` property. Specifies drag and drop features. See the Help documentation for more information.

  #### Returns Promise<Dnd>

  The value of `dnd` property.

### getEditMode

- getEditMode(): Promise<string>

- Gets the value of `editMode` property. Specifies if the table is read-only or editable. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `editMode` property.

### getEditRow

- getEditRow(): Promise<object>

- Gets the value of `editRow` property. Specifies the row that is currently being edited. See the Help documentation for more information.

  #### Returns Promise<object>

  The value of `editRow` property.

### getFirstSelectedRow

- getFirstSelectedRow(): Promise<FirstSelectedRow>

- Gets the value of `firstSelectedRow` property. Read-only property used for retrieving the key and data of the first selected row. See the Help documentation for more information.

  #### Returns Promise<FirstSelectedRow>

  The value of `firstSelectedRow` property.

### getHorizontalGridVisible

- getHorizontalGridVisible(): Promise<string>

- Gets the value of `horizontalGridVisible` property. Specifies the visibility of the horizontal gridlines. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `horizontalGridVisible` property.

### getInsertRowDisplay

- getInsertRowDisplay(): Promise<object>

- Gets the value of `insertRowDisplay` property. Specifies the visible location of the insert new row when addRowTemplate or addRowCellTemplate is present.

  #### Returns Promise<object>

  The value of `insertRowDisplay` property.

### getLayout

- getLayout(): Promise<string>

- Gets the value of `layout` property. The column sizing method used for the Table and its columns.

  #### Returns Promise<string>

  The value of `layout` property.

### getLocation

- getLocation(): Promise<ILocation>

- #### Returns Promise<ILocation>

  #### Inherit Doc

  Inherited from OjWebElement.getLocation

### getProperty

- getProperty<T>(propertyName): Promise<T>

- Get a named property value from this component. This function will wait for the application's busy context to complete before attempting to get the property value.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The name of the property

  #### Returns Promise<T>

  A Promise that yields a value for the named property.

  Inherited from OjWebElement.getProperty

### getRect

- getRect(): Promise<IRectangle>

- #### Returns Promise<IRectangle>

  #### Inherit Doc

  Inherited from OjWebElement.getRect

### getRow

- getRow(): Promise<Row>

- Gets the value of `row` property. Customizes the functionality of each row in the table.

  #### Returns Promise<Row>

  The value of `row` property.

### getRowRenderer

- getRowRenderer(): Promise<null>

- Gets the value of `rowRenderer` property. A function that returns row content. The function takes a context argument, provided by the table. See the Help documentation for more information.

  #### Returns Promise<null>

  The value of `rowRenderer` property.

### getScrollPolicy

- getScrollPolicy(): Promise<string>

- Gets the value of `scrollPolicy` property. Specifies how data are fetched as user scrolls down the table.

  #### Returns Promise<string>

  The value of `scrollPolicy` property.

### getScrollPolicyOptions

- getScrollPolicyOptions(): Promise<null | ScrollPolicyOptions>

- Gets the value of `scrollPolicyOptions` property. Specifies fetch options for scrolling behaviors that trigger data fetches.

  #### Returns Promise<null | ScrollPolicyOptions>

  The value of `scrollPolicyOptions` property.

### getScrollPosition

- getScrollPosition(): Promise<ScrollPosition>

- Gets the value of `scrollPosition` property. Specifies the scroll position of the table. See the Help documentation for more information.

  #### Returns Promise<ScrollPosition>

  The value of `scrollPosition` property.

### getScrollToKey

- getScrollToKey(): Promise<null | string>

- Gets the value of `scrollToKey` property. Specifies the behavior when Table needs to scroll to a position based on an item key.

  #### Returns Promise<null | string>

  The value of `scrollToKey` property.

### getSelectAllControl

- getSelectAllControl(): Promise<string>

- Gets the value of `selectAllControl` property. Specifies the visibility of the select all control. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `selectAllControl` property.

### getSelected

- getSelected(): Promise<Selected>

- Gets the value of `selected` property. Specifies the current selected rows and/or columns in the table. See the Help documentation for more information.

  #### Returns Promise<Selected>

  The value of `selected` property.

### getSelection

- getSelection(): Promise<object[]>

- Gets the value of `selection` property. Specifies the current selections in the table. See the Help documentation for more information.

  #### Returns Promise<object[]>

  The value of `selection` property.

  #### Deprecated

  Since 7.0.0. Use selected attribute instead.

### getSelectionMode

- getSelectionMode(): Promise<null | SelectionMode>

- Gets the value of `selectionMode` property. Specifies the row and column selection modes.

  #### Returns Promise<null | SelectionMode>

  The value of `selectionMode` property.

### getSelectionRequired

- getSelectionRequired(): Promise<boolean>

- Gets the value of `selectionRequired` property. Specifies whether selection is required on the Table.

  #### Returns Promise<boolean>

  The value of `selectionRequired` property.

### getSize

- getSize(): Promise<ISize>

- #### Returns Promise<ISize>

  #### Inherit Doc

  Inherited from OjWebElement.getSize

### getText

- getText(): Promise<string>

- #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjWebElement.getText

### getTranslations

- getTranslations(): Promise<null | Translations>

- Gets the value of `translations` property. A collection of translated resources from the translation bundle, or null if this component has no resources.

  #### Returns Promise<null | Translations>

  The value of `translations` property.

### getVerticalGridVisible

- getVerticalGridVisible(): Promise<string>

- Gets the value of `verticalGridVisible` property. Specifies the visibility of the vertical gridlines. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `verticalGridVisible` property.

### `Protected` hasSize

- hasSize(): Condition<Promise<boolean>>

- Create a wait condition that is satisfied when the element's DOM has a non-zero size.

  #### Returns Condition<Promise<boolean>>

  The Condition to be used with driver.wait() that's satisfied when the element's DOM has a non-zero size.

  #### Deprecated

  Since 11.0.0. Call the appropriate WebElement method to test the size of the element.

  Inherited from OjWebElement.hasSize

### `Protected` hasVisibility

- hasVisibility(): Condition<Promise<boolean>>

- Create a wait condition that is satisfid when the element is visible. The condition is satisfied when the element is displayed, as reported by #isDisplayed, and is scrolled into view. This is method is deprecated. Use WebElement.isDisplayed instead to test the display of the element, and scroll it into view if necessary.

  #### Returns Condition<Promise<boolean>>

  #### Deprecated

  Inherited from OjWebElement.hasVisibility

### isDisplayed

- isDisplayed(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from OjWebElement.isDisplayed

### isEnabled

- isEnabled(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from OjWebElement.isEnabled

### isSelected

- isSelected(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from OjWebElement.isSelected

### sendKeys

- sendKeys(...varArgs): Promise<void>

- #### Parameters

  - ##### `Rest` ...varArgs: (string | number | Promise<string | number>)[]

  #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjWebElement.sendKeys

### `Protected` setProperty

- setProperty<T>(propertyName, value): Promise<void>

- Set a property value on the remote element. This function first waits for the BusyContext to clear before setting the property, then after setting, waits again to ensure that no additional busy states were created due to the property setting.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The property name to set

  - ##### value: T

    The value to set for the property

  #### Returns Promise<void>

  A Promise which resolves when the remote property has been set to the value. Any value returned from the call to set the remote property is returned in the Promise.

  Inherited from OjWebElement.setProperty

### submit

- submit(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjWebElement.submit

### takeScreenshot

- takeScreenshot(optScroll?): Promise<string>

- #### Parameters

  - ##### `Optional` optScroll: boolean

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjWebElement.takeScreenshot

### whenBusyContextReady

- whenBusyContextReady(): Promise<void>

- Returns a Promise that is resolved when the application's busy state reports ready. This method checks only that the application's busy context is ready, and not that the DOM element is actually displayed or has a physical size, such as is the case with #whenReady. Operations which are read-only in nature should call this method prior to execution.

  #### Returns Promise<void>

  A Promise which is resolved when the page's busy state is ready.

  Inherited from OjWebElement.whenBusyContextReady

### whenReady

- whenReady(): Promise<void>

- Returns a Promise that is resolved when the element is ready for interaction--it is visible, has a size, and the app's busy context is ready. Operations on the DOM which rely on its physical location and size to be in a "ready" state should use this command, such as clicking, sending keys, locating child elements, and so on.

  #### Returns Promise<void>

  A Promise that's resolved when all conditions are met.

  Inherited from OjWebElement.whenReady

Generated using TypeDoc